@import 'mixins/mixins';
@import 'mixins/utils';
@import 'common/var';
@import 'select-dropdown';
@import 'input';
@import 'tag';
@import 'option';
@import 'option-group';
@import 'scrollbar';

@include b(select) {
  display: block;
  position: relative;
  $self: &;

  .el-select__tags > span {
    display: contents;
  }

  .el-input__inner {
    cursor: pointer;
    padding-right: 35px;

    border: 2px solid #495271 !important;
    border-radius: 5px;

    &:hover,
    &:focus {
      border: 2px solid #495271;
    }
  }

  &[border] {
    .el-input__inner {
      border-color: $--color-border !important;
      background-color: inherit;

      &:hover {
        border-color: $--color-border !important;
      }

      &:focus {
        outline: none;
        border-color: $--input-focus-border;
      }
    }

    &[line] {
      .el-input__inner {
        border-radius: 0;
        border-left: none !important;
        border-right: none !important;
        border-top: none !important;
        padding: 12px 0 0 0;
      }
    }
  }

  .el-input {
    & .el-select__caret {
      color: $--select-input-color;
      font-size: $--select-input-font-size;
      transition: transform 0.3s;
      transform: rotateZ(180deg);
      cursor: pointer;

      @include when(reverse) {
        transform: rotateZ(0deg);
      }

      @include when(show-close) {
        font-size: $--select-font-size;
        text-align: center;
        transform: rotateZ(180deg);
        border-radius: $--border-radius-circle;
        color: $--select-input-color;
        transition: $--color-transition-base;

        &:hover {
          color: $--select-close-hover-color;
        }
      }
    }

    &.is-disabled {
      & .el-input__inner {
        cursor: not-allowed;

        &:hover {
          border-color: $--select-disabled-border;
        }
      }
    }

    &.is-focus .el-input__inner {
      border-color: $--select-input-focus-border-color;
    }
  }

  > .el-input {
    display: block;
  }

  @include e(input) {
    border: none;
    outline: none;
    padding: 0;
    margin-left: 15px;
    color: $--select-multiple-input-color;
    font-size: $--select-font-size;
    appearance: none;
    height: 28px;
    background-color: transparent;

    @include when(mini) {
      height: 14px;
    }
  }

  @include e(close) {
    cursor: pointer;
    position: absolute;
    top: 8px;
    z-index: $--index-top;
    right: 25px;
    color: $--select-input-color;
    line-height: 18px;
    font-size: $--select-input-font-size;

    &:hover {
      color: $--select-close-hover-color;
    }
  }

  @include e(tags) {
    position: absolute;
    line-height: normal;
    white-space: normal;
    z-index: $--index-normal;
    top: 50%;
    transform: translateY(-50%);
    display: flex;
    align-items: center;
    flex-wrap: wrap;
  }

  .el-tag__close {
    margin-top: -2px;
  }

  .el-tag {
    box-sizing: border-box;
    border-color: transparent;
    margin: 2px 0 2px 6px;
    background-color: #41485c;

    &__close.el-icon-close {
      &::before,
      &::after {
        background-color: #9badd6;
      }
    }
  }
}
